#ifndef __included_l2_api_json
#define __included_l2_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_l2_flags;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_all;
extern vapi_msg_id_t vapi_msg_id_l2_fib_table_dump;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_dump;
extern vapi_msg_id_t vapi_msg_id_l2_xconnect_details;
extern vapi_msg_id_t vapi_msg_id_l2fib_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_bd_reply;
extern vapi_msg_id_t vapi_msg_id_l2_interface_pbb_tag_rewrite;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_int_reply;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_bridge_flags_reply;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_bd;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_int;
extern vapi_msg_id_t vapi_msg_id_l2_fib_table_details;
extern vapi_msg_id_t vapi_msg_id_l2_fib_clear_table_reply;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_set_mac_age;
extern vapi_msg_id_t vapi_msg_id_l2fib_flush_all_reply;
extern vapi_msg_id_t vapi_msg_id_l2_macs_event;
extern vapi_msg_id_t vapi_msg_id_l2_flags_reply;
extern vapi_msg_id_t vapi_msg_id_l2_fib_clear_table;
extern vapi_msg_id_t vapi_msg_id_l2_interface_vlan_tag_rewrite_reply;
extern vapi_msg_id_t vapi_msg_id_bridge_flags;
extern vapi_msg_id_t vapi_msg_id_l2fib_add_del;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_set_mac_age_reply;
extern vapi_msg_id_t vapi_msg_id_want_l2_macs_events;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_add_del;
extern vapi_msg_id_t vapi_msg_id_bridge_domain_details;
extern vapi_msg_id_t vapi_msg_id_l2_interface_pbb_tag_rewrite_reply;
extern vapi_msg_id_t vapi_msg_id_l2_xconnect_dump;
extern vapi_msg_id_t vapi_msg_id_want_l2_macs_events_reply;
extern vapi_msg_id_t vapi_msg_id_l2_interface_vlan_tag_rewrite;

#define DEFINE_VAPI_MSG_IDS_L2_API_JSON\
  vapi_msg_id_t vapi_msg_id_l2_flags;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_all;\
  vapi_msg_id_t vapi_msg_id_l2_fib_table_dump;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_dump;\
  vapi_msg_id_t vapi_msg_id_l2_xconnect_details;\
  vapi_msg_id_t vapi_msg_id_l2fib_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_bd_reply;\
  vapi_msg_id_t vapi_msg_id_l2_interface_pbb_tag_rewrite;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_int_reply;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_bridge_flags_reply;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_bd;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_int;\
  vapi_msg_id_t vapi_msg_id_l2_fib_table_details;\
  vapi_msg_id_t vapi_msg_id_l2_fib_clear_table_reply;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_set_mac_age;\
  vapi_msg_id_t vapi_msg_id_l2fib_flush_all_reply;\
  vapi_msg_id_t vapi_msg_id_l2_macs_event;\
  vapi_msg_id_t vapi_msg_id_l2_flags_reply;\
  vapi_msg_id_t vapi_msg_id_l2_fib_clear_table;\
  vapi_msg_id_t vapi_msg_id_l2_interface_vlan_tag_rewrite_reply;\
  vapi_msg_id_t vapi_msg_id_bridge_flags;\
  vapi_msg_id_t vapi_msg_id_l2fib_add_del;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_set_mac_age_reply;\
  vapi_msg_id_t vapi_msg_id_want_l2_macs_events;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_add_del;\
  vapi_msg_id_t vapi_msg_id_bridge_domain_details;\
  vapi_msg_id_t vapi_msg_id_l2_interface_pbb_tag_rewrite_reply;\
  vapi_msg_id_t vapi_msg_id_l2_xconnect_dump;\
  vapi_msg_id_t vapi_msg_id_want_l2_macs_events_reply;\
  vapi_msg_id_t vapi_msg_id_l2_interface_vlan_tag_rewrite;


typedef struct __attribute__((__packed__)) {
  u32 sw_if_index;
  u8 mac_addr[6];
  u8 is_del;
  u8 spare;
} vapi_type_mac_entry;

typedef struct __attribute__((__packed__)) {
  u32 context;
  u32 sw_if_index;
  u8 shg;
} vapi_type_bridge_domain_sw_if;

typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u8 is_set;
  u32 feature_bitmap; 
} vapi_payload_l2_flags;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2_flags payload;
} vapi_msg_l2_flags;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_l2fib_flush_all;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id; 
} vapi_payload_l2_fib_table_dump;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2_fib_table_dump payload;
} vapi_msg_l2_fib_table_dump;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id; 
} vapi_payload_bridge_domain_dump;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bridge_domain_dump payload;
} vapi_msg_bridge_domain_dump;

typedef struct __attribute__ ((__packed__)) {
  u32 rx_sw_if_index;
  u32 tx_sw_if_index; 
} vapi_payload_l2_xconnect_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_xconnect_details payload;
} vapi_msg_l2_xconnect_details;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2fib_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2fib_add_del_reply payload;
} vapi_msg_l2fib_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2fib_flush_bd_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2fib_flush_bd_reply payload;
} vapi_msg_l2fib_flush_bd_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u32 vtr_op;
  u16 outer_tag;
  u8 b_dmac[6];
  u8 b_smac[6];
  u16 b_vlanid;
  u32 i_sid; 
} vapi_payload_l2_interface_pbb_tag_rewrite;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2_interface_pbb_tag_rewrite payload;
} vapi_msg_l2_interface_pbb_tag_rewrite;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2fib_flush_int_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2fib_flush_int_reply payload;
} vapi_msg_l2fib_flush_int_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bridge_domain_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bridge_domain_add_del_reply payload;
} vapi_msg_bridge_domain_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 resulting_feature_bitmap; 
} vapi_payload_bridge_flags_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bridge_flags_reply payload;
} vapi_msg_bridge_flags_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id; 
} vapi_payload_l2fib_flush_bd;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2fib_flush_bd payload;
} vapi_msg_l2fib_flush_bd;

typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index; 
} vapi_payload_l2fib_flush_int;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2fib_flush_int payload;
} vapi_msg_l2fib_flush_int;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id;
  u64 mac;
  u32 sw_if_index;
  u8 static_mac;
  u8 filter_mac;
  u8 bvi_mac; 
} vapi_payload_l2_fib_table_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_fib_table_details payload;
} vapi_msg_l2_fib_table_details;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2_fib_clear_table_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_fib_clear_table_reply payload;
} vapi_msg_l2_fib_clear_table_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id;
  u8 mac_age; 
} vapi_payload_bridge_domain_set_mac_age;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bridge_domain_set_mac_age payload;
} vapi_msg_bridge_domain_set_mac_age;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2fib_flush_all_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2fib_flush_all_reply payload;
} vapi_msg_l2fib_flush_all_reply;

typedef struct __attribute__ ((__packed__)) {
  u16 _vl_msg_id;
  u32 client_index;
  u32 pid;
  u32 n_macs;
  vapi_type_mac_entry mac[0]; 
} vapi_payload_l2_macs_event;

typedef struct __attribute__ ((__packed__)) {

  vapi_payload_l2_macs_event payload;
} vapi_msg_l2_macs_event;

typedef struct __attribute__ ((__packed__)) {
  i32 retval;
  u32 resulting_feature_bitmap; 
} vapi_payload_l2_flags_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_flags_reply payload;
} vapi_msg_l2_flags_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_l2_fib_clear_table;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2_interface_vlan_tag_rewrite_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_interface_vlan_tag_rewrite_reply payload;
} vapi_msg_l2_interface_vlan_tag_rewrite_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id;
  u8 is_set;
  u32 feature_bitmap; 
} vapi_payload_bridge_flags;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bridge_flags payload;
} vapi_msg_bridge_flags;

typedef struct __attribute__ ((__packed__)) {
  u64 mac;
  u32 bd_id;
  u32 sw_if_index;
  u8 is_add;
  u8 static_mac;
  u8 filter_mac;
  u8 bvi_mac; 
} vapi_payload_l2fib_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2fib_add_del payload;
} vapi_msg_l2fib_add_del;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_bridge_domain_set_mac_age_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bridge_domain_set_mac_age_reply payload;
} vapi_msg_bridge_domain_set_mac_age_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 learn_limit;
  u8 scan_delay;
  u8 max_macs_in_event;
  u8 enable_disable;
  u32 pid; 
} vapi_payload_want_l2_macs_events;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_want_l2_macs_events payload;
} vapi_msg_want_l2_macs_events;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id;
  u8 flood;
  u8 uu_flood;
  u8 forward;
  u8 learn;
  u8 arp_term;
  u8 mac_age;
  u8 bd_tag[64];
  u8 is_add; 
} vapi_payload_bridge_domain_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_bridge_domain_add_del payload;
} vapi_msg_bridge_domain_add_del;

typedef struct __attribute__ ((__packed__)) {
  u32 bd_id;
  u8 flood;
  u8 uu_flood;
  u8 forward;
  u8 learn;
  u8 arp_term;
  u8 mac_age;
  u8 bd_tag[64];
  u32 bvi_sw_if_index;
  u32 n_sw_ifs;
  vapi_type_bridge_domain_sw_if sw_if_details[0]; 
} vapi_payload_bridge_domain_details;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_bridge_domain_details payload;
} vapi_msg_bridge_domain_details;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_l2_interface_pbb_tag_rewrite_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_l2_interface_pbb_tag_rewrite_reply payload;
} vapi_msg_l2_interface_pbb_tag_rewrite_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
} vapi_msg_l2_xconnect_dump;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_want_l2_macs_events_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_want_l2_macs_events_reply payload;
} vapi_msg_want_l2_macs_events_reply;

typedef struct __attribute__ ((__packed__)) {
  u32 sw_if_index;
  u32 vtr_op;
  u32 push_dot1q;
  u32 tag1;
  u32 tag2; 
} vapi_payload_l2_interface_vlan_tag_rewrite;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_l2_interface_vlan_tag_rewrite payload;
} vapi_msg_l2_interface_vlan_tag_rewrite;


static inline void vapi_type_mac_entry_hton(vapi_type_mac_entry *msg)
{
  msg->sw_if_index = htobe32(msg->sw_if_index);
}

static inline void vapi_type_mac_entry_ntoh(vapi_type_mac_entry *msg)
{
  msg->sw_if_index = be32toh(msg->sw_if_index);
}

static inline void vapi_type_bridge_domain_sw_if_hton(vapi_type_bridge_domain_sw_if *msg)
{
  msg->context = htobe32(msg->context);
  msg->sw_if_index = htobe32(msg->sw_if_index);
}

static inline void vapi_type_bridge_domain_sw_if_ntoh(vapi_type_bridge_domain_sw_if *msg)
{
  msg->context = be32toh(msg->context);
  msg->sw_if_index = be32toh(msg->sw_if_index);
}

static inline void vapi_msg_l2_flags_payload_hton(vapi_payload_l2_flags *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
  payload->feature_bitmap = htobe32(payload->feature_bitmap);
}

static inline void vapi_msg_l2_flags_payload_ntoh(vapi_payload_l2_flags *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
  payload->feature_bitmap = be32toh(payload->feature_bitmap);
}

static inline uword vapi_calc_l2_flags_msg_size(vapi_msg_l2_flags *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_flags_hton(vapi_msg_l2_flags *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_flags'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2_flags_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_flags_ntoh(vapi_msg_l2_flags *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_flags'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2_flags_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_l2fib_flush_all_msg_size(vapi_msg_l2fib_flush_all *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_all_hton(vapi_msg_l2fib_flush_all *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_all'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_l2fib_flush_all_ntoh(vapi_msg_l2fib_flush_all *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_all'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_l2_fib_table_dump_payload_hton(vapi_payload_l2_fib_table_dump *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
}

static inline void vapi_msg_l2_fib_table_dump_payload_ntoh(vapi_payload_l2_fib_table_dump *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
}

static inline uword vapi_calc_l2_fib_table_dump_msg_size(vapi_msg_l2_fib_table_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_fib_table_dump_hton(vapi_msg_l2_fib_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_table_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2_fib_table_dump_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_fib_table_dump_ntoh(vapi_msg_l2_fib_table_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_table_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2_fib_table_dump_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_dump_payload_hton(vapi_payload_bridge_domain_dump *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
}

static inline void vapi_msg_bridge_domain_dump_payload_ntoh(vapi_payload_bridge_domain_dump *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
}

static inline uword vapi_calc_bridge_domain_dump_msg_size(vapi_msg_bridge_domain_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_domain_dump_hton(vapi_msg_bridge_domain_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bridge_domain_dump_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_dump_ntoh(vapi_msg_bridge_domain_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_dump_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_xconnect_details_payload_hton(vapi_payload_l2_xconnect_details *payload)
{
  payload->rx_sw_if_index = htobe32(payload->rx_sw_if_index);
  payload->tx_sw_if_index = htobe32(payload->tx_sw_if_index);
}

static inline void vapi_msg_l2_xconnect_details_payload_ntoh(vapi_payload_l2_xconnect_details *payload)
{
  payload->rx_sw_if_index = be32toh(payload->rx_sw_if_index);
  payload->tx_sw_if_index = be32toh(payload->tx_sw_if_index);
}

static inline uword vapi_calc_l2_xconnect_details_msg_size(vapi_msg_l2_xconnect_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_xconnect_details_hton(vapi_msg_l2_xconnect_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_xconnect_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_xconnect_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_xconnect_details_ntoh(vapi_msg_l2_xconnect_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_xconnect_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_xconnect_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_add_del_reply_payload_hton(vapi_payload_l2fib_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2fib_add_del_reply_payload_ntoh(vapi_payload_l2fib_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2fib_add_del_reply_msg_size(vapi_msg_l2fib_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_add_del_reply_hton(vapi_msg_l2fib_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2fib_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_add_del_reply_ntoh(vapi_msg_l2fib_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2fib_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_bd_reply_payload_hton(vapi_payload_l2fib_flush_bd_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2fib_flush_bd_reply_payload_ntoh(vapi_payload_l2fib_flush_bd_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2fib_flush_bd_reply_msg_size(vapi_msg_l2fib_flush_bd_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_bd_reply_hton(vapi_msg_l2fib_flush_bd_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_bd_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2fib_flush_bd_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_bd_reply_ntoh(vapi_msg_l2fib_flush_bd_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_bd_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2fib_flush_bd_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_payload_hton(vapi_payload_l2_interface_pbb_tag_rewrite *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
  payload->vtr_op = htobe32(payload->vtr_op);
  payload->outer_tag = htobe16(payload->outer_tag);
  payload->b_vlanid = htobe16(payload->b_vlanid);
  payload->i_sid = htobe32(payload->i_sid);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_payload_ntoh(vapi_payload_l2_interface_pbb_tag_rewrite *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
  payload->vtr_op = be32toh(payload->vtr_op);
  payload->outer_tag = be16toh(payload->outer_tag);
  payload->b_vlanid = be16toh(payload->b_vlanid);
  payload->i_sid = be32toh(payload->i_sid);
}

static inline uword vapi_calc_l2_interface_pbb_tag_rewrite_msg_size(vapi_msg_l2_interface_pbb_tag_rewrite *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_hton(vapi_msg_l2_interface_pbb_tag_rewrite *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_pbb_tag_rewrite'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2_interface_pbb_tag_rewrite_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_ntoh(vapi_msg_l2_interface_pbb_tag_rewrite *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_pbb_tag_rewrite'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2_interface_pbb_tag_rewrite_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_int_reply_payload_hton(vapi_payload_l2fib_flush_int_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2fib_flush_int_reply_payload_ntoh(vapi_payload_l2fib_flush_int_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2fib_flush_int_reply_msg_size(vapi_msg_l2fib_flush_int_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_int_reply_hton(vapi_msg_l2fib_flush_int_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_int_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2fib_flush_int_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_int_reply_ntoh(vapi_msg_l2fib_flush_int_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_int_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2fib_flush_int_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_add_del_reply_payload_hton(vapi_payload_bridge_domain_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bridge_domain_add_del_reply_payload_ntoh(vapi_payload_bridge_domain_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bridge_domain_add_del_reply_msg_size(vapi_msg_bridge_domain_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_domain_add_del_reply_hton(vapi_msg_bridge_domain_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bridge_domain_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_add_del_reply_ntoh(vapi_msg_bridge_domain_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_flags_reply_payload_hton(vapi_payload_bridge_flags_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->resulting_feature_bitmap = htobe32(payload->resulting_feature_bitmap);
}

static inline void vapi_msg_bridge_flags_reply_payload_ntoh(vapi_payload_bridge_flags_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->resulting_feature_bitmap = be32toh(payload->resulting_feature_bitmap);
}

static inline uword vapi_calc_bridge_flags_reply_msg_size(vapi_msg_bridge_flags_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_flags_reply_hton(vapi_msg_bridge_flags_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_flags_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bridge_flags_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_flags_reply_ntoh(vapi_msg_bridge_flags_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_flags_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bridge_flags_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_bd_payload_hton(vapi_payload_l2fib_flush_bd *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
}

static inline void vapi_msg_l2fib_flush_bd_payload_ntoh(vapi_payload_l2fib_flush_bd *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
}

static inline uword vapi_calc_l2fib_flush_bd_msg_size(vapi_msg_l2fib_flush_bd *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_bd_hton(vapi_msg_l2fib_flush_bd *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_bd'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2fib_flush_bd_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_bd_ntoh(vapi_msg_l2fib_flush_bd *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_bd'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2fib_flush_bd_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_int_payload_hton(vapi_payload_l2fib_flush_int *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_l2fib_flush_int_payload_ntoh(vapi_payload_l2fib_flush_int *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_l2fib_flush_int_msg_size(vapi_msg_l2fib_flush_int *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_int_hton(vapi_msg_l2fib_flush_int *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_int'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2fib_flush_int_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_int_ntoh(vapi_msg_l2fib_flush_int *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_int'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2fib_flush_int_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_fib_table_details_payload_hton(vapi_payload_l2_fib_table_details *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
  payload->mac = htobe64(payload->mac);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_l2_fib_table_details_payload_ntoh(vapi_payload_l2_fib_table_details *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
  payload->mac = be64toh(payload->mac);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_l2_fib_table_details_msg_size(vapi_msg_l2_fib_table_details *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_fib_table_details_hton(vapi_msg_l2_fib_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_table_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_fib_table_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_fib_table_details_ntoh(vapi_msg_l2_fib_table_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_table_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_fib_table_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_fib_clear_table_reply_payload_hton(vapi_payload_l2_fib_clear_table_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2_fib_clear_table_reply_payload_ntoh(vapi_payload_l2_fib_clear_table_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2_fib_clear_table_reply_msg_size(vapi_msg_l2_fib_clear_table_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_fib_clear_table_reply_hton(vapi_msg_l2_fib_clear_table_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_clear_table_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_fib_clear_table_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_fib_clear_table_reply_ntoh(vapi_msg_l2_fib_clear_table_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_clear_table_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_fib_clear_table_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_set_mac_age_payload_hton(vapi_payload_bridge_domain_set_mac_age *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
}

static inline void vapi_msg_bridge_domain_set_mac_age_payload_ntoh(vapi_payload_bridge_domain_set_mac_age *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
}

static inline uword vapi_calc_bridge_domain_set_mac_age_msg_size(vapi_msg_bridge_domain_set_mac_age *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_domain_set_mac_age_hton(vapi_msg_bridge_domain_set_mac_age *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_set_mac_age'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bridge_domain_set_mac_age_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_set_mac_age_ntoh(vapi_msg_bridge_domain_set_mac_age *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_set_mac_age'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_set_mac_age_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_all_reply_payload_hton(vapi_payload_l2fib_flush_all_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2fib_flush_all_reply_payload_ntoh(vapi_payload_l2fib_flush_all_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2fib_flush_all_reply_msg_size(vapi_msg_l2fib_flush_all_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_flush_all_reply_hton(vapi_msg_l2fib_flush_all_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_all_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2fib_flush_all_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_flush_all_reply_ntoh(vapi_msg_l2fib_flush_all_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_flush_all_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2fib_flush_all_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_macs_event_payload_hton(vapi_payload_l2_macs_event *payload)
{
  payload->_vl_msg_id = htobe16(payload->_vl_msg_id);
  payload->client_index = htobe32(payload->client_index);
  payload->pid = htobe32(payload->pid);
  payload->n_macs = htobe32(payload->n_macs);
  do { unsigned i; for (i = 0; i < be32toh(payload->n_macs); ++i) { vapi_type_mac_entry_hton(&payload->mac[i]); } } while(0);
}

static inline void vapi_msg_l2_macs_event_payload_ntoh(vapi_payload_l2_macs_event *payload)
{
  payload->_vl_msg_id = be16toh(payload->_vl_msg_id);
  payload->client_index = be32toh(payload->client_index);
  payload->pid = be32toh(payload->pid);
  payload->n_macs = be32toh(payload->n_macs);
  do { unsigned i; for (i = 0; i < payload->n_macs; ++i) { vapi_type_mac_entry_ntoh(&payload->mac[i]); } } while(0);
}

static inline uword vapi_calc_l2_macs_event_msg_size(vapi_msg_l2_macs_event *msg)
{
  return sizeof(*msg)+ msg->payload.n_macs * sizeof(msg->payload.mac[0]);
}

static inline void vapi_msg_l2_macs_event_hton(vapi_msg_l2_macs_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_macs_event'@%p to big endian", msg);

  vapi_msg_l2_macs_event_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_macs_event_ntoh(vapi_msg_l2_macs_event *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_macs_event'@%p to host byte order", msg);

  vapi_msg_l2_macs_event_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_flags_reply_payload_hton(vapi_payload_l2_flags_reply *payload)
{
  payload->retval = htobe32(payload->retval);
  payload->resulting_feature_bitmap = htobe32(payload->resulting_feature_bitmap);
}

static inline void vapi_msg_l2_flags_reply_payload_ntoh(vapi_payload_l2_flags_reply *payload)
{
  payload->retval = be32toh(payload->retval);
  payload->resulting_feature_bitmap = be32toh(payload->resulting_feature_bitmap);
}

static inline uword vapi_calc_l2_flags_reply_msg_size(vapi_msg_l2_flags_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_flags_reply_hton(vapi_msg_l2_flags_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_flags_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_flags_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_flags_reply_ntoh(vapi_msg_l2_flags_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_flags_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_flags_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_l2_fib_clear_table_msg_size(vapi_msg_l2_fib_clear_table *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_fib_clear_table_hton(vapi_msg_l2_fib_clear_table *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_clear_table'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_l2_fib_clear_table_ntoh(vapi_msg_l2_fib_clear_table *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_fib_clear_table'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_reply_payload_hton(vapi_payload_l2_interface_vlan_tag_rewrite_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_reply_payload_ntoh(vapi_payload_l2_interface_vlan_tag_rewrite_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2_interface_vlan_tag_rewrite_reply_msg_size(vapi_msg_l2_interface_vlan_tag_rewrite_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_reply_hton(vapi_msg_l2_interface_vlan_tag_rewrite_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_vlan_tag_rewrite_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_interface_vlan_tag_rewrite_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_reply_ntoh(vapi_msg_l2_interface_vlan_tag_rewrite_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_vlan_tag_rewrite_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_interface_vlan_tag_rewrite_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_flags_payload_hton(vapi_payload_bridge_flags *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
  payload->feature_bitmap = htobe32(payload->feature_bitmap);
}

static inline void vapi_msg_bridge_flags_payload_ntoh(vapi_payload_bridge_flags *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
  payload->feature_bitmap = be32toh(payload->feature_bitmap);
}

static inline uword vapi_calc_bridge_flags_msg_size(vapi_msg_bridge_flags *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_flags_hton(vapi_msg_bridge_flags *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_flags'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bridge_flags_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_flags_ntoh(vapi_msg_bridge_flags *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_flags'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bridge_flags_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2fib_add_del_payload_hton(vapi_payload_l2fib_add_del *payload)
{
  payload->mac = htobe64(payload->mac);
  payload->bd_id = htobe32(payload->bd_id);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_l2fib_add_del_payload_ntoh(vapi_payload_l2fib_add_del *payload)
{
  payload->mac = be64toh(payload->mac);
  payload->bd_id = be32toh(payload->bd_id);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_l2fib_add_del_msg_size(vapi_msg_l2fib_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2fib_add_del_hton(vapi_msg_l2fib_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2fib_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2fib_add_del_ntoh(vapi_msg_l2fib_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2fib_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2fib_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_set_mac_age_reply_payload_hton(vapi_payload_bridge_domain_set_mac_age_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_bridge_domain_set_mac_age_reply_payload_ntoh(vapi_payload_bridge_domain_set_mac_age_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_bridge_domain_set_mac_age_reply_msg_size(vapi_msg_bridge_domain_set_mac_age_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_domain_set_mac_age_reply_hton(vapi_msg_bridge_domain_set_mac_age_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_set_mac_age_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bridge_domain_set_mac_age_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_set_mac_age_reply_ntoh(vapi_msg_bridge_domain_set_mac_age_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_set_mac_age_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_set_mac_age_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_want_l2_macs_events_payload_hton(vapi_payload_want_l2_macs_events *payload)
{
  payload->learn_limit = htobe32(payload->learn_limit);
  payload->pid = htobe32(payload->pid);
}

static inline void vapi_msg_want_l2_macs_events_payload_ntoh(vapi_payload_want_l2_macs_events *payload)
{
  payload->learn_limit = be32toh(payload->learn_limit);
  payload->pid = be32toh(payload->pid);
}

static inline uword vapi_calc_want_l2_macs_events_msg_size(vapi_msg_want_l2_macs_events *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_l2_macs_events_hton(vapi_msg_want_l2_macs_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_l2_macs_events'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_want_l2_macs_events_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_l2_macs_events_ntoh(vapi_msg_want_l2_macs_events *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_l2_macs_events'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_want_l2_macs_events_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_add_del_payload_hton(vapi_payload_bridge_domain_add_del *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
}

static inline void vapi_msg_bridge_domain_add_del_payload_ntoh(vapi_payload_bridge_domain_add_del *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
}

static inline uword vapi_calc_bridge_domain_add_del_msg_size(vapi_msg_bridge_domain_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_bridge_domain_add_del_hton(vapi_msg_bridge_domain_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_bridge_domain_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_add_del_ntoh(vapi_msg_bridge_domain_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_bridge_domain_details_payload_hton(vapi_payload_bridge_domain_details *payload)
{
  payload->bd_id = htobe32(payload->bd_id);
  payload->bvi_sw_if_index = htobe32(payload->bvi_sw_if_index);
  payload->n_sw_ifs = htobe32(payload->n_sw_ifs);
  do { unsigned i; for (i = 0; i < be32toh(payload->n_sw_ifs); ++i) { vapi_type_bridge_domain_sw_if_hton(&payload->sw_if_details[i]); } } while(0);
}

static inline void vapi_msg_bridge_domain_details_payload_ntoh(vapi_payload_bridge_domain_details *payload)
{
  payload->bd_id = be32toh(payload->bd_id);
  payload->bvi_sw_if_index = be32toh(payload->bvi_sw_if_index);
  payload->n_sw_ifs = be32toh(payload->n_sw_ifs);
  do { unsigned i; for (i = 0; i < payload->n_sw_ifs; ++i) { vapi_type_bridge_domain_sw_if_ntoh(&payload->sw_if_details[i]); } } while(0);
}

static inline uword vapi_calc_bridge_domain_details_msg_size(vapi_msg_bridge_domain_details *msg)
{
  return sizeof(*msg)+ msg->payload.n_sw_ifs * sizeof(msg->payload.sw_if_details[0]);
}

static inline void vapi_msg_bridge_domain_details_hton(vapi_msg_bridge_domain_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_details'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_bridge_domain_details_payload_hton(&msg->payload);
}

static inline void vapi_msg_bridge_domain_details_ntoh(vapi_msg_bridge_domain_details *msg)
{
  VAPI_DBG("Swapping `vapi_msg_bridge_domain_details'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_bridge_domain_details_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_reply_payload_hton(vapi_payload_l2_interface_pbb_tag_rewrite_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_reply_payload_ntoh(vapi_payload_l2_interface_pbb_tag_rewrite_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_l2_interface_pbb_tag_rewrite_reply_msg_size(vapi_msg_l2_interface_pbb_tag_rewrite_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_reply_hton(vapi_msg_l2_interface_pbb_tag_rewrite_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_pbb_tag_rewrite_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_l2_interface_pbb_tag_rewrite_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_interface_pbb_tag_rewrite_reply_ntoh(vapi_msg_l2_interface_pbb_tag_rewrite_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_pbb_tag_rewrite_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_l2_interface_pbb_tag_rewrite_reply_payload_ntoh(&msg->payload);
}

static inline uword vapi_calc_l2_xconnect_dump_msg_size(vapi_msg_l2_xconnect_dump *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_xconnect_dump_hton(vapi_msg_l2_xconnect_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_xconnect_dump'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);

}

static inline void vapi_msg_l2_xconnect_dump_ntoh(vapi_msg_l2_xconnect_dump *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_xconnect_dump'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);

}

static inline void vapi_msg_want_l2_macs_events_reply_payload_hton(vapi_payload_want_l2_macs_events_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_want_l2_macs_events_reply_payload_ntoh(vapi_payload_want_l2_macs_events_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_want_l2_macs_events_reply_msg_size(vapi_msg_want_l2_macs_events_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_want_l2_macs_events_reply_hton(vapi_msg_want_l2_macs_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_l2_macs_events_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_want_l2_macs_events_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_want_l2_macs_events_reply_ntoh(vapi_msg_want_l2_macs_events_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_want_l2_macs_events_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_want_l2_macs_events_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_payload_hton(vapi_payload_l2_interface_vlan_tag_rewrite *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
  payload->vtr_op = htobe32(payload->vtr_op);
  payload->push_dot1q = htobe32(payload->push_dot1q);
  payload->tag1 = htobe32(payload->tag1);
  payload->tag2 = htobe32(payload->tag2);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_payload_ntoh(vapi_payload_l2_interface_vlan_tag_rewrite *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
  payload->vtr_op = be32toh(payload->vtr_op);
  payload->push_dot1q = be32toh(payload->push_dot1q);
  payload->tag1 = be32toh(payload->tag1);
  payload->tag2 = be32toh(payload->tag2);
}

static inline uword vapi_calc_l2_interface_vlan_tag_rewrite_msg_size(vapi_msg_l2_interface_vlan_tag_rewrite *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_hton(vapi_msg_l2_interface_vlan_tag_rewrite *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_vlan_tag_rewrite'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_l2_interface_vlan_tag_rewrite_payload_hton(&msg->payload);
}

static inline void vapi_msg_l2_interface_vlan_tag_rewrite_ntoh(vapi_msg_l2_interface_vlan_tag_rewrite *msg)
{
  VAPI_DBG("Swapping `vapi_msg_l2_interface_vlan_tag_rewrite'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_l2_interface_vlan_tag_rewrite_payload_ntoh(&msg->payload);
}

static inline vapi_msg_l2_flags* vapi_alloc_l2_flags(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_flags *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_flags);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_flags*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_flags);

  return msg;
}

static inline vapi_error_e vapi_l2_flags(struct vapi_ctx_s *ctx,
  vapi_msg_l2_flags *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_flags_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_flags_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_flags_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2fib_flush_all* vapi_alloc_l2fib_flush_all(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2fib_flush_all *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2fib_flush_all);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2fib_flush_all*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2fib_flush_all);

  return msg;
}

static inline vapi_error_e vapi_l2fib_flush_all(struct vapi_ctx_s *ctx,
  vapi_msg_l2fib_flush_all *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2fib_flush_all_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2fib_flush_all_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2fib_flush_all_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2_fib_table_dump* vapi_alloc_l2_fib_table_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_fib_table_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_fib_table_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_fib_table_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_fib_table_dump);

  return msg;
}

static inline vapi_error_e vapi_l2_fib_table_dump(struct vapi_ctx_s *ctx,
  vapi_msg_l2_fib_table_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_fib_table_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_fib_table_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_fib_table_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bridge_domain_dump* vapi_alloc_bridge_domain_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_bridge_domain_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_bridge_domain_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bridge_domain_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bridge_domain_dump);

  return msg;
}

static inline vapi_error_e vapi_bridge_domain_dump(struct vapi_ctx_s *ctx,
  vapi_msg_bridge_domain_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bridge_domain_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bridge_domain_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bridge_domain_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2_interface_pbb_tag_rewrite* vapi_alloc_l2_interface_pbb_tag_rewrite(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_interface_pbb_tag_rewrite *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_interface_pbb_tag_rewrite);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_interface_pbb_tag_rewrite*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_interface_pbb_tag_rewrite);

  return msg;
}

static inline vapi_error_e vapi_l2_interface_pbb_tag_rewrite(struct vapi_ctx_s *ctx,
  vapi_msg_l2_interface_pbb_tag_rewrite *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_interface_pbb_tag_rewrite_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_interface_pbb_tag_rewrite_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_interface_pbb_tag_rewrite_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2fib_flush_bd* vapi_alloc_l2fib_flush_bd(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2fib_flush_bd *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2fib_flush_bd);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2fib_flush_bd*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2fib_flush_bd);

  return msg;
}

static inline vapi_error_e vapi_l2fib_flush_bd(struct vapi_ctx_s *ctx,
  vapi_msg_l2fib_flush_bd *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2fib_flush_bd_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2fib_flush_bd_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2fib_flush_bd_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2fib_flush_int* vapi_alloc_l2fib_flush_int(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2fib_flush_int *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2fib_flush_int);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2fib_flush_int*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2fib_flush_int);

  return msg;
}

static inline vapi_error_e vapi_l2fib_flush_int(struct vapi_ctx_s *ctx,
  vapi_msg_l2fib_flush_int *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2fib_flush_int_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2fib_flush_int_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2fib_flush_int_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bridge_domain_set_mac_age* vapi_alloc_bridge_domain_set_mac_age(struct vapi_ctx_s *ctx)
{
  vapi_msg_bridge_domain_set_mac_age *msg = NULL;
  const size_t size = sizeof(vapi_msg_bridge_domain_set_mac_age);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bridge_domain_set_mac_age*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bridge_domain_set_mac_age);

  return msg;
}

static inline vapi_error_e vapi_bridge_domain_set_mac_age(struct vapi_ctx_s *ctx,
  vapi_msg_bridge_domain_set_mac_age *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bridge_domain_set_mac_age_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bridge_domain_set_mac_age_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bridge_domain_set_mac_age_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2_fib_clear_table* vapi_alloc_l2_fib_clear_table(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_fib_clear_table *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_fib_clear_table);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_fib_clear_table*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_fib_clear_table);

  return msg;
}

static inline vapi_error_e vapi_l2_fib_clear_table(struct vapi_ctx_s *ctx,
  vapi_msg_l2_fib_clear_table *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_fib_clear_table_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_fib_clear_table_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_fib_clear_table_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bridge_flags* vapi_alloc_bridge_flags(struct vapi_ctx_s *ctx)
{
  vapi_msg_bridge_flags *msg = NULL;
  const size_t size = sizeof(vapi_msg_bridge_flags);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bridge_flags*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bridge_flags);

  return msg;
}

static inline vapi_error_e vapi_bridge_flags(struct vapi_ctx_s *ctx,
  vapi_msg_bridge_flags *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bridge_flags_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bridge_flags_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bridge_flags_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2fib_add_del* vapi_alloc_l2fib_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2fib_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2fib_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2fib_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2fib_add_del);

  return msg;
}

static inline vapi_error_e vapi_l2fib_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_l2fib_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2fib_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2fib_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2fib_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_want_l2_macs_events* vapi_alloc_want_l2_macs_events(struct vapi_ctx_s *ctx)
{
  vapi_msg_want_l2_macs_events *msg = NULL;
  const size_t size = sizeof(vapi_msg_want_l2_macs_events);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_want_l2_macs_events*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_want_l2_macs_events);

  return msg;
}

static inline vapi_error_e vapi_want_l2_macs_events(struct vapi_ctx_s *ctx,
  vapi_msg_want_l2_macs_events *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_want_l2_macs_events_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_want_l2_macs_events_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_want_l2_macs_events_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_bridge_domain_add_del* vapi_alloc_bridge_domain_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_bridge_domain_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_bridge_domain_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_bridge_domain_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_bridge_domain_add_del);

  return msg;
}

static inline vapi_error_e vapi_bridge_domain_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_bridge_domain_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_bridge_domain_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_bridge_domain_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_bridge_domain_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2_xconnect_dump* vapi_alloc_l2_xconnect_dump(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_xconnect_dump *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_xconnect_dump);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_xconnect_dump*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_xconnect_dump);

  return msg;
}

static inline vapi_error_e vapi_l2_xconnect_dump(struct vapi_ctx_s *ctx,
  vapi_msg_l2_xconnect_dump *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_xconnect_details *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_xconnect_dump_hton(msg);
  if (VAPI_OK == (rv = vapi_send_with_control_ping (ctx, msg, req_context))) {
    vapi_store_request(ctx, req_context, true, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_xconnect_dump_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_l2_interface_vlan_tag_rewrite* vapi_alloc_l2_interface_vlan_tag_rewrite(struct vapi_ctx_s *ctx)
{
  vapi_msg_l2_interface_vlan_tag_rewrite *msg = NULL;
  const size_t size = sizeof(vapi_msg_l2_interface_vlan_tag_rewrite);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_l2_interface_vlan_tag_rewrite*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_l2_interface_vlan_tag_rewrite);

  return msg;
}

static inline vapi_error_e vapi_l2_interface_vlan_tag_rewrite(struct vapi_ctx_s *ctx,
  vapi_msg_l2_interface_vlan_tag_rewrite *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_l2_interface_vlan_tag_rewrite_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_l2_interface_vlan_tag_rewrite_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_l2_interface_vlan_tag_rewrite_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_l2_flags()
{
  static const char name[] = "l2_flags";
  static const char name_with_crc[] = "l2_flags_987fb8e1";
  static vapi_message_desc_t __vapi_metadata_l2_flags = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2_flags, payload),
    sizeof(vapi_msg_l2_flags),
    (generic_swap_fn_t)vapi_msg_l2_flags_hton,
    (generic_swap_fn_t)vapi_msg_l2_flags_ntoh,
    ~0,
  };

  vapi_msg_id_l2_flags = vapi_register_msg(&__vapi_metadata_l2_flags);
  VAPI_DBG("Assigned msg id %d to l2_flags", vapi_msg_id_l2_flags);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_all()
{
  static const char name[] = "l2fib_flush_all";
  static const char name_with_crc[] = "l2fib_flush_all_abc3e39e";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_all = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    ~0,
    sizeof(vapi_msg_l2fib_flush_all),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_all_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_all_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_all = vapi_register_msg(&__vapi_metadata_l2fib_flush_all);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_all", vapi_msg_id_l2fib_flush_all);
}

static void __attribute__((constructor)) __vapi_constructor_l2_fib_table_dump()
{
  static const char name[] = "l2_fib_table_dump";
  static const char name_with_crc[] = "l2_fib_table_dump_edcbdcf6";
  static vapi_message_desc_t __vapi_metadata_l2_fib_table_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2_fib_table_dump, payload),
    sizeof(vapi_msg_l2_fib_table_dump),
    (generic_swap_fn_t)vapi_msg_l2_fib_table_dump_hton,
    (generic_swap_fn_t)vapi_msg_l2_fib_table_dump_ntoh,
    ~0,
  };

  vapi_msg_id_l2_fib_table_dump = vapi_register_msg(&__vapi_metadata_l2_fib_table_dump);
  VAPI_DBG("Assigned msg id %d to l2_fib_table_dump", vapi_msg_id_l2_fib_table_dump);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_dump()
{
  static const char name[] = "bridge_domain_dump";
  static const char name_with_crc[] = "bridge_domain_dump_68d5401d";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bridge_domain_dump, payload),
    sizeof(vapi_msg_bridge_domain_dump),
    (generic_swap_fn_t)vapi_msg_bridge_domain_dump_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_dump_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_dump = vapi_register_msg(&__vapi_metadata_bridge_domain_dump);
  VAPI_DBG("Assigned msg id %d to bridge_domain_dump", vapi_msg_id_bridge_domain_dump);
}

static void __attribute__((constructor)) __vapi_constructor_l2_xconnect_details()
{
  static const char name[] = "l2_xconnect_details";
  static const char name_with_crc[] = "l2_xconnect_details_8983dff7";
  static vapi_message_desc_t __vapi_metadata_l2_xconnect_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_xconnect_details, payload),
    sizeof(vapi_msg_l2_xconnect_details),
    (generic_swap_fn_t)vapi_msg_l2_xconnect_details_hton,
    (generic_swap_fn_t)vapi_msg_l2_xconnect_details_ntoh,
    ~0,
  };

  vapi_msg_id_l2_xconnect_details = vapi_register_msg(&__vapi_metadata_l2_xconnect_details);
  VAPI_DBG("Assigned msg id %d to l2_xconnect_details", vapi_msg_id_l2_xconnect_details);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_add_del_reply()
{
  static const char name[] = "l2fib_add_del_reply";
  static const char name_with_crc[] = "l2fib_add_del_reply_1be0875a";
  static vapi_message_desc_t __vapi_metadata_l2fib_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2fib_add_del_reply, payload),
    sizeof(vapi_msg_l2fib_add_del_reply),
    (generic_swap_fn_t)vapi_msg_l2fib_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_add_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_add_del_reply = vapi_register_msg(&__vapi_metadata_l2fib_add_del_reply);
  VAPI_DBG("Assigned msg id %d to l2fib_add_del_reply", vapi_msg_id_l2fib_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_bd_reply()
{
  static const char name[] = "l2fib_flush_bd_reply";
  static const char name_with_crc[] = "l2fib_flush_bd_reply_a68d5609";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_bd_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2fib_flush_bd_reply, payload),
    sizeof(vapi_msg_l2fib_flush_bd_reply),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_bd_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_bd_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_bd_reply = vapi_register_msg(&__vapi_metadata_l2fib_flush_bd_reply);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_bd_reply", vapi_msg_id_l2fib_flush_bd_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2_interface_pbb_tag_rewrite()
{
  static const char name[] = "l2_interface_pbb_tag_rewrite";
  static const char name_with_crc[] = "l2_interface_pbb_tag_rewrite_b7706c15";
  static vapi_message_desc_t __vapi_metadata_l2_interface_pbb_tag_rewrite = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2_interface_pbb_tag_rewrite, payload),
    sizeof(vapi_msg_l2_interface_pbb_tag_rewrite),
    (generic_swap_fn_t)vapi_msg_l2_interface_pbb_tag_rewrite_hton,
    (generic_swap_fn_t)vapi_msg_l2_interface_pbb_tag_rewrite_ntoh,
    ~0,
  };

  vapi_msg_id_l2_interface_pbb_tag_rewrite = vapi_register_msg(&__vapi_metadata_l2_interface_pbb_tag_rewrite);
  VAPI_DBG("Assigned msg id %d to l2_interface_pbb_tag_rewrite", vapi_msg_id_l2_interface_pbb_tag_rewrite);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_int_reply()
{
  static const char name[] = "l2fib_flush_int_reply";
  static const char name_with_crc[] = "l2fib_flush_int_reply_aacfc0d0";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_int_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2fib_flush_int_reply, payload),
    sizeof(vapi_msg_l2fib_flush_int_reply),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_int_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_int_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_int_reply = vapi_register_msg(&__vapi_metadata_l2fib_flush_int_reply);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_int_reply", vapi_msg_id_l2fib_flush_int_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_add_del_reply()
{
  static const char name[] = "bridge_domain_add_del_reply";
  static const char name_with_crc[] = "bridge_domain_add_del_reply_d5e138e4";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bridge_domain_add_del_reply, payload),
    sizeof(vapi_msg_bridge_domain_add_del_reply),
    (generic_swap_fn_t)vapi_msg_bridge_domain_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_add_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_add_del_reply = vapi_register_msg(&__vapi_metadata_bridge_domain_add_del_reply);
  VAPI_DBG("Assigned msg id %d to bridge_domain_add_del_reply", vapi_msg_id_bridge_domain_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_flags_reply()
{
  static const char name[] = "bridge_flags_reply";
  static const char name_with_crc[] = "bridge_flags_reply_fa6b7397";
  static vapi_message_desc_t __vapi_metadata_bridge_flags_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bridge_flags_reply, payload),
    sizeof(vapi_msg_bridge_flags_reply),
    (generic_swap_fn_t)vapi_msg_bridge_flags_reply_hton,
    (generic_swap_fn_t)vapi_msg_bridge_flags_reply_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_flags_reply = vapi_register_msg(&__vapi_metadata_bridge_flags_reply);
  VAPI_DBG("Assigned msg id %d to bridge_flags_reply", vapi_msg_id_bridge_flags_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_bd()
{
  static const char name[] = "l2fib_flush_bd";
  static const char name_with_crc[] = "l2fib_flush_bd_82b7f182";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_bd = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2fib_flush_bd, payload),
    sizeof(vapi_msg_l2fib_flush_bd),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_bd_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_bd_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_bd = vapi_register_msg(&__vapi_metadata_l2fib_flush_bd);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_bd", vapi_msg_id_l2fib_flush_bd);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_int()
{
  static const char name[] = "l2fib_flush_int";
  static const char name_with_crc[] = "l2fib_flush_int_a1216623";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_int = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2fib_flush_int, payload),
    sizeof(vapi_msg_l2fib_flush_int),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_int_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_int_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_int = vapi_register_msg(&__vapi_metadata_l2fib_flush_int);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_int", vapi_msg_id_l2fib_flush_int);
}

static void __attribute__((constructor)) __vapi_constructor_l2_fib_table_details()
{
  static const char name[] = "l2_fib_table_details";
  static const char name_with_crc[] = "l2_fib_table_details_07426ad7";
  static vapi_message_desc_t __vapi_metadata_l2_fib_table_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_fib_table_details, payload),
    sizeof(vapi_msg_l2_fib_table_details),
    (generic_swap_fn_t)vapi_msg_l2_fib_table_details_hton,
    (generic_swap_fn_t)vapi_msg_l2_fib_table_details_ntoh,
    ~0,
  };

  vapi_msg_id_l2_fib_table_details = vapi_register_msg(&__vapi_metadata_l2_fib_table_details);
  VAPI_DBG("Assigned msg id %d to l2_fib_table_details", vapi_msg_id_l2_fib_table_details);
}

static void __attribute__((constructor)) __vapi_constructor_l2_fib_clear_table_reply()
{
  static const char name[] = "l2_fib_clear_table_reply";
  static const char name_with_crc[] = "l2_fib_clear_table_reply_0425b038";
  static vapi_message_desc_t __vapi_metadata_l2_fib_clear_table_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_fib_clear_table_reply, payload),
    sizeof(vapi_msg_l2_fib_clear_table_reply),
    (generic_swap_fn_t)vapi_msg_l2_fib_clear_table_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2_fib_clear_table_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2_fib_clear_table_reply = vapi_register_msg(&__vapi_metadata_l2_fib_clear_table_reply);
  VAPI_DBG("Assigned msg id %d to l2_fib_clear_table_reply", vapi_msg_id_l2_fib_clear_table_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_set_mac_age()
{
  static const char name[] = "bridge_domain_set_mac_age";
  static const char name_with_crc[] = "bridge_domain_set_mac_age_f58c37aa";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_set_mac_age = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bridge_domain_set_mac_age, payload),
    sizeof(vapi_msg_bridge_domain_set_mac_age),
    (generic_swap_fn_t)vapi_msg_bridge_domain_set_mac_age_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_set_mac_age_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_set_mac_age = vapi_register_msg(&__vapi_metadata_bridge_domain_set_mac_age);
  VAPI_DBG("Assigned msg id %d to bridge_domain_set_mac_age", vapi_msg_id_bridge_domain_set_mac_age);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_flush_all_reply()
{
  static const char name[] = "l2fib_flush_all_reply";
  static const char name_with_crc[] = "l2fib_flush_all_reply_ef3a3245";
  static vapi_message_desc_t __vapi_metadata_l2fib_flush_all_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2fib_flush_all_reply, payload),
    sizeof(vapi_msg_l2fib_flush_all_reply),
    (generic_swap_fn_t)vapi_msg_l2fib_flush_all_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_flush_all_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_flush_all_reply = vapi_register_msg(&__vapi_metadata_l2fib_flush_all_reply);
  VAPI_DBG("Assigned msg id %d to l2fib_flush_all_reply", vapi_msg_id_l2fib_flush_all_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2_macs_event()
{
  static const char name[] = "l2_macs_event";
  static const char name_with_crc[] = "l2_macs_event_2a1cc4f5";
  static vapi_message_desc_t __vapi_metadata_l2_macs_event = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    false,
    0,
    offsetof(vapi_msg_l2_macs_event, payload),
    sizeof(vapi_msg_l2_macs_event),
    (generic_swap_fn_t)vapi_msg_l2_macs_event_hton,
    (generic_swap_fn_t)vapi_msg_l2_macs_event_ntoh,
    ~0,
  };

  vapi_msg_id_l2_macs_event = vapi_register_msg(&__vapi_metadata_l2_macs_event);
  VAPI_DBG("Assigned msg id %d to l2_macs_event", vapi_msg_id_l2_macs_event);
}

static void __attribute__((constructor)) __vapi_constructor_l2_flags_reply()
{
  static const char name[] = "l2_flags_reply";
  static const char name_with_crc[] = "l2_flags_reply_bd749594";
  static vapi_message_desc_t __vapi_metadata_l2_flags_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_flags_reply, payload),
    sizeof(vapi_msg_l2_flags_reply),
    (generic_swap_fn_t)vapi_msg_l2_flags_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2_flags_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2_flags_reply = vapi_register_msg(&__vapi_metadata_l2_flags_reply);
  VAPI_DBG("Assigned msg id %d to l2_flags_reply", vapi_msg_id_l2_flags_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2_fib_clear_table()
{
  static const char name[] = "l2_fib_clear_table";
  static const char name_with_crc[] = "l2_fib_clear_table_40dc61e3";
  static vapi_message_desc_t __vapi_metadata_l2_fib_clear_table = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    ~0,
    sizeof(vapi_msg_l2_fib_clear_table),
    (generic_swap_fn_t)vapi_msg_l2_fib_clear_table_hton,
    (generic_swap_fn_t)vapi_msg_l2_fib_clear_table_ntoh,
    ~0,
  };

  vapi_msg_id_l2_fib_clear_table = vapi_register_msg(&__vapi_metadata_l2_fib_clear_table);
  VAPI_DBG("Assigned msg id %d to l2_fib_clear_table", vapi_msg_id_l2_fib_clear_table);
}

static void __attribute__((constructor)) __vapi_constructor_l2_interface_vlan_tag_rewrite_reply()
{
  static const char name[] = "l2_interface_vlan_tag_rewrite_reply";
  static const char name_with_crc[] = "l2_interface_vlan_tag_rewrite_reply_901eddfb";
  static vapi_message_desc_t __vapi_metadata_l2_interface_vlan_tag_rewrite_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_interface_vlan_tag_rewrite_reply, payload),
    sizeof(vapi_msg_l2_interface_vlan_tag_rewrite_reply),
    (generic_swap_fn_t)vapi_msg_l2_interface_vlan_tag_rewrite_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2_interface_vlan_tag_rewrite_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2_interface_vlan_tag_rewrite_reply = vapi_register_msg(&__vapi_metadata_l2_interface_vlan_tag_rewrite_reply);
  VAPI_DBG("Assigned msg id %d to l2_interface_vlan_tag_rewrite_reply", vapi_msg_id_l2_interface_vlan_tag_rewrite_reply);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_flags()
{
  static const char name[] = "bridge_flags";
  static const char name_with_crc[] = "bridge_flags_c1d50251";
  static vapi_message_desc_t __vapi_metadata_bridge_flags = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bridge_flags, payload),
    sizeof(vapi_msg_bridge_flags),
    (generic_swap_fn_t)vapi_msg_bridge_flags_hton,
    (generic_swap_fn_t)vapi_msg_bridge_flags_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_flags = vapi_register_msg(&__vapi_metadata_bridge_flags);
  VAPI_DBG("Assigned msg id %d to bridge_flags", vapi_msg_id_bridge_flags);
}

static void __attribute__((constructor)) __vapi_constructor_l2fib_add_del()
{
  static const char name[] = "l2fib_add_del";
  static const char name_with_crc[] = "l2fib_add_del_604cc582";
  static vapi_message_desc_t __vapi_metadata_l2fib_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2fib_add_del, payload),
    sizeof(vapi_msg_l2fib_add_del),
    (generic_swap_fn_t)vapi_msg_l2fib_add_del_hton,
    (generic_swap_fn_t)vapi_msg_l2fib_add_del_ntoh,
    ~0,
  };

  vapi_msg_id_l2fib_add_del = vapi_register_msg(&__vapi_metadata_l2fib_add_del);
  VAPI_DBG("Assigned msg id %d to l2fib_add_del", vapi_msg_id_l2fib_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_set_mac_age_reply()
{
  static const char name[] = "bridge_domain_set_mac_age_reply";
  static const char name_with_crc[] = "bridge_domain_set_mac_age_reply_c127a682";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_set_mac_age_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bridge_domain_set_mac_age_reply, payload),
    sizeof(vapi_msg_bridge_domain_set_mac_age_reply),
    (generic_swap_fn_t)vapi_msg_bridge_domain_set_mac_age_reply_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_set_mac_age_reply_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_set_mac_age_reply = vapi_register_msg(&__vapi_metadata_bridge_domain_set_mac_age_reply);
  VAPI_DBG("Assigned msg id %d to bridge_domain_set_mac_age_reply", vapi_msg_id_bridge_domain_set_mac_age_reply);
}

static void __attribute__((constructor)) __vapi_constructor_want_l2_macs_events()
{
  static const char name[] = "want_l2_macs_events";
  static const char name_with_crc[] = "want_l2_macs_events_c043c52c";
  static vapi_message_desc_t __vapi_metadata_want_l2_macs_events = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_want_l2_macs_events, payload),
    sizeof(vapi_msg_want_l2_macs_events),
    (generic_swap_fn_t)vapi_msg_want_l2_macs_events_hton,
    (generic_swap_fn_t)vapi_msg_want_l2_macs_events_ntoh,
    ~0,
  };

  vapi_msg_id_want_l2_macs_events = vapi_register_msg(&__vapi_metadata_want_l2_macs_events);
  VAPI_DBG("Assigned msg id %d to want_l2_macs_events", vapi_msg_id_want_l2_macs_events);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_add_del()
{
  static const char name[] = "bridge_domain_add_del";
  static const char name_with_crc[] = "bridge_domain_add_del_e9894b51";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_bridge_domain_add_del, payload),
    sizeof(vapi_msg_bridge_domain_add_del),
    (generic_swap_fn_t)vapi_msg_bridge_domain_add_del_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_add_del_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_add_del = vapi_register_msg(&__vapi_metadata_bridge_domain_add_del);
  VAPI_DBG("Assigned msg id %d to bridge_domain_add_del", vapi_msg_id_bridge_domain_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_bridge_domain_details()
{
  static const char name[] = "bridge_domain_details";
  static const char name_with_crc[] = "bridge_domain_details_ff7d2b54";
  static vapi_message_desc_t __vapi_metadata_bridge_domain_details = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_bridge_domain_details, payload),
    sizeof(vapi_msg_bridge_domain_details),
    (generic_swap_fn_t)vapi_msg_bridge_domain_details_hton,
    (generic_swap_fn_t)vapi_msg_bridge_domain_details_ntoh,
    ~0,
  };

  vapi_msg_id_bridge_domain_details = vapi_register_msg(&__vapi_metadata_bridge_domain_details);
  VAPI_DBG("Assigned msg id %d to bridge_domain_details", vapi_msg_id_bridge_domain_details);
}

static void __attribute__((constructor)) __vapi_constructor_l2_interface_pbb_tag_rewrite_reply()
{
  static const char name[] = "l2_interface_pbb_tag_rewrite_reply";
  static const char name_with_crc[] = "l2_interface_pbb_tag_rewrite_reply_2d083312";
  static vapi_message_desc_t __vapi_metadata_l2_interface_pbb_tag_rewrite_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_l2_interface_pbb_tag_rewrite_reply, payload),
    sizeof(vapi_msg_l2_interface_pbb_tag_rewrite_reply),
    (generic_swap_fn_t)vapi_msg_l2_interface_pbb_tag_rewrite_reply_hton,
    (generic_swap_fn_t)vapi_msg_l2_interface_pbb_tag_rewrite_reply_ntoh,
    ~0,
  };

  vapi_msg_id_l2_interface_pbb_tag_rewrite_reply = vapi_register_msg(&__vapi_metadata_l2_interface_pbb_tag_rewrite_reply);
  VAPI_DBG("Assigned msg id %d to l2_interface_pbb_tag_rewrite_reply", vapi_msg_id_l2_interface_pbb_tag_rewrite_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2_xconnect_dump()
{
  static const char name[] = "l2_xconnect_dump";
  static const char name_with_crc[] = "l2_xconnect_dump_794eaafb";
  static vapi_message_desc_t __vapi_metadata_l2_xconnect_dump = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    ~0,
    sizeof(vapi_msg_l2_xconnect_dump),
    (generic_swap_fn_t)vapi_msg_l2_xconnect_dump_hton,
    (generic_swap_fn_t)vapi_msg_l2_xconnect_dump_ntoh,
    ~0,
  };

  vapi_msg_id_l2_xconnect_dump = vapi_register_msg(&__vapi_metadata_l2_xconnect_dump);
  VAPI_DBG("Assigned msg id %d to l2_xconnect_dump", vapi_msg_id_l2_xconnect_dump);
}

static void __attribute__((constructor)) __vapi_constructor_want_l2_macs_events_reply()
{
  static const char name[] = "want_l2_macs_events_reply";
  static const char name_with_crc[] = "want_l2_macs_events_reply_97d6535f";
  static vapi_message_desc_t __vapi_metadata_want_l2_macs_events_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_want_l2_macs_events_reply, payload),
    sizeof(vapi_msg_want_l2_macs_events_reply),
    (generic_swap_fn_t)vapi_msg_want_l2_macs_events_reply_hton,
    (generic_swap_fn_t)vapi_msg_want_l2_macs_events_reply_ntoh,
    ~0,
  };

  vapi_msg_id_want_l2_macs_events_reply = vapi_register_msg(&__vapi_metadata_want_l2_macs_events_reply);
  VAPI_DBG("Assigned msg id %d to want_l2_macs_events_reply", vapi_msg_id_want_l2_macs_events_reply);
}

static void __attribute__((constructor)) __vapi_constructor_l2_interface_vlan_tag_rewrite()
{
  static const char name[] = "l2_interface_vlan_tag_rewrite";
  static const char name_with_crc[] = "l2_interface_vlan_tag_rewrite_b9dcbd39";
  static vapi_message_desc_t __vapi_metadata_l2_interface_vlan_tag_rewrite = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_l2_interface_vlan_tag_rewrite, payload),
    sizeof(vapi_msg_l2_interface_vlan_tag_rewrite),
    (generic_swap_fn_t)vapi_msg_l2_interface_vlan_tag_rewrite_hton,
    (generic_swap_fn_t)vapi_msg_l2_interface_vlan_tag_rewrite_ntoh,
    ~0,
  };

  vapi_msg_id_l2_interface_vlan_tag_rewrite = vapi_register_msg(&__vapi_metadata_l2_interface_vlan_tag_rewrite);
  VAPI_DBG("Assigned msg id %d to l2_interface_vlan_tag_rewrite", vapi_msg_id_l2_interface_vlan_tag_rewrite);
}


static inline void vapi_set_vapi_msg_l2_xconnect_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_xconnect_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_xconnect_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2fib_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2fib_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2fib_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2fib_flush_bd_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2fib_flush_bd_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2fib_flush_bd_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2fib_flush_int_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2fib_flush_int_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2fib_flush_int_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bridge_domain_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bridge_domain_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bridge_domain_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bridge_flags_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bridge_flags_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bridge_flags_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_fib_table_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_fib_table_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_fib_table_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_fib_clear_table_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_fib_clear_table_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_fib_clear_table_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2fib_flush_all_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2fib_flush_all_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2fib_flush_all_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_macs_event_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_macs_event *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_macs_event, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_flags_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_flags_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_flags_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_interface_vlan_tag_rewrite_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_interface_vlan_tag_rewrite_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_interface_vlan_tag_rewrite_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bridge_domain_set_mac_age_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bridge_domain_set_mac_age_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bridge_domain_set_mac_age_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_bridge_domain_details_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_bridge_domain_details *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_bridge_domain_details, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_l2_interface_pbb_tag_rewrite_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_l2_interface_pbb_tag_rewrite_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_l2_interface_pbb_tag_rewrite_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_want_l2_macs_events_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_want_l2_macs_events_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_want_l2_macs_events_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
