#ifndef __included_sr_api_json
#define __included_sr_api_json

#include <stdlib.h>
#include <stddef.h>
#include <arpa/inet.h>
#include <vapi/vapi_internal.h>
#include <vapi/vapi.h>
#include <vapi/vapi_dbg.h>

#ifdef __cplusplus
extern "C" {
#endif
#include <vapi/vpe.api.vapi.h>

extern vapi_msg_id_t vapi_msg_id_sr_policy_mod_reply;
extern vapi_msg_id_t vapi_msg_id_sr_steering_add_del;
extern vapi_msg_id_t vapi_msg_id_sr_policy_del;
extern vapi_msg_id_t vapi_msg_id_sr_localsid_add_del;
extern vapi_msg_id_t vapi_msg_id_sr_steering_add_del_reply;
extern vapi_msg_id_t vapi_msg_id_sr_policy_del_reply;
extern vapi_msg_id_t vapi_msg_id_sr_policy_add_reply;
extern vapi_msg_id_t vapi_msg_id_sr_localsid_add_del_reply;

#define DEFINE_VAPI_MSG_IDS_SR_API_JSON\
  vapi_msg_id_t vapi_msg_id_sr_policy_mod_reply;\
  vapi_msg_id_t vapi_msg_id_sr_steering_add_del;\
  vapi_msg_id_t vapi_msg_id_sr_policy_del;\
  vapi_msg_id_t vapi_msg_id_sr_localsid_add_del;\
  vapi_msg_id_t vapi_msg_id_sr_steering_add_del_reply;\
  vapi_msg_id_t vapi_msg_id_sr_policy_del_reply;\
  vapi_msg_id_t vapi_msg_id_sr_policy_add_reply;\
  vapi_msg_id_t vapi_msg_id_sr_localsid_add_del_reply;


typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_sr_policy_mod_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sr_policy_mod_reply payload;
} vapi_msg_sr_policy_mod_reply;

typedef struct __attribute__ ((__packed__)) {
  u8 is_del;
  u8 bsid_addr[16];
  u32 sr_policy_index;
  u32 table_id;
  u8 prefix_addr[16];
  u32 mask_width;
  u32 sw_if_index;
  u8 traffic_type; 
} vapi_payload_sr_steering_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_sr_steering_add_del payload;
} vapi_msg_sr_steering_add_del;

typedef struct __attribute__ ((__packed__)) {
  u8 bsid_addr[16];
  u32 sr_policy_index; 
} vapi_payload_sr_policy_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_sr_policy_del payload;
} vapi_msg_sr_policy_del;

typedef struct __attribute__ ((__packed__)) {
  u8 is_del;
  u8 localsid_addr[16];
  u8 end_psp;
  u8 behavior;
  u32 sw_if_index;
  u32 vlan_index;
  u32 fib_table;
  u8 nh_addr[16]; 
} vapi_payload_sr_localsid_add_del;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header2_t header;
  vapi_payload_sr_localsid_add_del payload;
} vapi_msg_sr_localsid_add_del;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_sr_steering_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sr_steering_add_del_reply payload;
} vapi_msg_sr_steering_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_sr_policy_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sr_policy_del_reply payload;
} vapi_msg_sr_policy_del_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_sr_policy_add_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sr_policy_add_reply payload;
} vapi_msg_sr_policy_add_reply;

typedef struct __attribute__ ((__packed__)) {
  i32 retval; 
} vapi_payload_sr_localsid_add_del_reply;

typedef struct __attribute__ ((__packed__)) {
  vapi_type_msg_header1_t header;
  vapi_payload_sr_localsid_add_del_reply payload;
} vapi_msg_sr_localsid_add_del_reply;


static inline void vapi_msg_sr_policy_mod_reply_payload_hton(vapi_payload_sr_policy_mod_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_sr_policy_mod_reply_payload_ntoh(vapi_payload_sr_policy_mod_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_sr_policy_mod_reply_msg_size(vapi_msg_sr_policy_mod_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_policy_mod_reply_hton(vapi_msg_sr_policy_mod_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_mod_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sr_policy_mod_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_policy_mod_reply_ntoh(vapi_msg_sr_policy_mod_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_mod_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sr_policy_mod_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_steering_add_del_payload_hton(vapi_payload_sr_steering_add_del *payload)
{
  payload->sr_policy_index = htobe32(payload->sr_policy_index);
  payload->table_id = htobe32(payload->table_id);
  payload->mask_width = htobe32(payload->mask_width);
  payload->sw_if_index = htobe32(payload->sw_if_index);
}

static inline void vapi_msg_sr_steering_add_del_payload_ntoh(vapi_payload_sr_steering_add_del *payload)
{
  payload->sr_policy_index = be32toh(payload->sr_policy_index);
  payload->table_id = be32toh(payload->table_id);
  payload->mask_width = be32toh(payload->mask_width);
  payload->sw_if_index = be32toh(payload->sw_if_index);
}

static inline uword vapi_calc_sr_steering_add_del_msg_size(vapi_msg_sr_steering_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_steering_add_del_hton(vapi_msg_sr_steering_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_steering_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_sr_steering_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_steering_add_del_ntoh(vapi_msg_sr_steering_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_steering_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_sr_steering_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_policy_del_payload_hton(vapi_payload_sr_policy_del *payload)
{
  payload->sr_policy_index = htobe32(payload->sr_policy_index);
}

static inline void vapi_msg_sr_policy_del_payload_ntoh(vapi_payload_sr_policy_del *payload)
{
  payload->sr_policy_index = be32toh(payload->sr_policy_index);
}

static inline uword vapi_calc_sr_policy_del_msg_size(vapi_msg_sr_policy_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_policy_del_hton(vapi_msg_sr_policy_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_sr_policy_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_policy_del_ntoh(vapi_msg_sr_policy_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_sr_policy_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_localsid_add_del_payload_hton(vapi_payload_sr_localsid_add_del *payload)
{
  payload->sw_if_index = htobe32(payload->sw_if_index);
  payload->vlan_index = htobe32(payload->vlan_index);
  payload->fib_table = htobe32(payload->fib_table);
}

static inline void vapi_msg_sr_localsid_add_del_payload_ntoh(vapi_payload_sr_localsid_add_del *payload)
{
  payload->sw_if_index = be32toh(payload->sw_if_index);
  payload->vlan_index = be32toh(payload->vlan_index);
  payload->fib_table = be32toh(payload->fib_table);
}

static inline uword vapi_calc_sr_localsid_add_del_msg_size(vapi_msg_sr_localsid_add_del *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_localsid_add_del_hton(vapi_msg_sr_localsid_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_localsid_add_del'@%p to big endian", msg);
  vapi_type_msg_header2_t_hton(&msg->header);
  vapi_msg_sr_localsid_add_del_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_localsid_add_del_ntoh(vapi_msg_sr_localsid_add_del *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_localsid_add_del'@%p to host byte order", msg);
  vapi_type_msg_header2_t_ntoh(&msg->header);
  vapi_msg_sr_localsid_add_del_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_steering_add_del_reply_payload_hton(vapi_payload_sr_steering_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_sr_steering_add_del_reply_payload_ntoh(vapi_payload_sr_steering_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_sr_steering_add_del_reply_msg_size(vapi_msg_sr_steering_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_steering_add_del_reply_hton(vapi_msg_sr_steering_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_steering_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sr_steering_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_steering_add_del_reply_ntoh(vapi_msg_sr_steering_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_steering_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sr_steering_add_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_policy_del_reply_payload_hton(vapi_payload_sr_policy_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_sr_policy_del_reply_payload_ntoh(vapi_payload_sr_policy_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_sr_policy_del_reply_msg_size(vapi_msg_sr_policy_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_policy_del_reply_hton(vapi_msg_sr_policy_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sr_policy_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_policy_del_reply_ntoh(vapi_msg_sr_policy_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sr_policy_del_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_policy_add_reply_payload_hton(vapi_payload_sr_policy_add_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_sr_policy_add_reply_payload_ntoh(vapi_payload_sr_policy_add_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_sr_policy_add_reply_msg_size(vapi_msg_sr_policy_add_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_policy_add_reply_hton(vapi_msg_sr_policy_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_add_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sr_policy_add_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_policy_add_reply_ntoh(vapi_msg_sr_policy_add_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_policy_add_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sr_policy_add_reply_payload_ntoh(&msg->payload);
}

static inline void vapi_msg_sr_localsid_add_del_reply_payload_hton(vapi_payload_sr_localsid_add_del_reply *payload)
{
  payload->retval = htobe32(payload->retval);
}

static inline void vapi_msg_sr_localsid_add_del_reply_payload_ntoh(vapi_payload_sr_localsid_add_del_reply *payload)
{
  payload->retval = be32toh(payload->retval);
}

static inline uword vapi_calc_sr_localsid_add_del_reply_msg_size(vapi_msg_sr_localsid_add_del_reply *msg)
{
  return sizeof(*msg);
}

static inline void vapi_msg_sr_localsid_add_del_reply_hton(vapi_msg_sr_localsid_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_localsid_add_del_reply'@%p to big endian", msg);
  vapi_type_msg_header1_t_hton(&msg->header);
  vapi_msg_sr_localsid_add_del_reply_payload_hton(&msg->payload);
}

static inline void vapi_msg_sr_localsid_add_del_reply_ntoh(vapi_msg_sr_localsid_add_del_reply *msg)
{
  VAPI_DBG("Swapping `vapi_msg_sr_localsid_add_del_reply'@%p to host byte order", msg);
  vapi_type_msg_header1_t_ntoh(&msg->header);
  vapi_msg_sr_localsid_add_del_reply_payload_ntoh(&msg->payload);
}

static inline vapi_msg_sr_steering_add_del* vapi_alloc_sr_steering_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_sr_steering_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_sr_steering_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_sr_steering_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_sr_steering_add_del);

  return msg;
}

static inline vapi_error_e vapi_sr_steering_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_sr_steering_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_sr_steering_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_sr_steering_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_sr_steering_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_sr_policy_del* vapi_alloc_sr_policy_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_sr_policy_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_sr_policy_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_sr_policy_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_sr_policy_del);

  return msg;
}

static inline vapi_error_e vapi_sr_policy_del(struct vapi_ctx_s *ctx,
  vapi_msg_sr_policy_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_sr_policy_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_sr_policy_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_sr_policy_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}


static inline vapi_msg_sr_localsid_add_del* vapi_alloc_sr_localsid_add_del(struct vapi_ctx_s *ctx)
{
  vapi_msg_sr_localsid_add_del *msg = NULL;
  const size_t size = sizeof(vapi_msg_sr_localsid_add_del);
  /* cast here required to play nicely with C++ world ... */
  msg = (vapi_msg_sr_localsid_add_del*)vapi_msg_alloc(ctx, size);
  if (!msg) {
    return NULL;
  }
  msg->header.client_index = vapi_get_client_index(ctx);
  msg->header.context = 0;
  msg->header._vl_msg_id = vapi_lookup_vl_msg_id(ctx, vapi_msg_id_sr_localsid_add_del);

  return msg;
}

static inline vapi_error_e vapi_sr_localsid_add_del(struct vapi_ctx_s *ctx,
  vapi_msg_sr_localsid_add_del *msg,
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx,
                           void *callback_ctx,
                           vapi_error_e rv,
                           bool is_last,
                           vapi_payload_sr_localsid_add_del_reply *reply),
  void *callback_ctx)
{
  if (!msg || !callback) {
    return VAPI_EINVAL;
  }
  if (vapi_is_nonblocking(ctx) && vapi_requests_full(ctx)) {
    return VAPI_EAGAIN;
  }
  vapi_error_e rv;
  if (VAPI_OK != (rv = vapi_producer_lock (ctx))) {
    return rv;
  }
  u32 req_context = vapi_gen_req_context(ctx);
  msg->header.context = req_context;
  vapi_msg_sr_localsid_add_del_hton(msg);
  if (VAPI_OK == (rv = vapi_send (ctx, msg))) {
    vapi_store_request(ctx, req_context, false, (vapi_cb_t)callback, callback_ctx);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
    if (vapi_is_nonblocking(ctx)) {
      rv = VAPI_OK;
    } else {
      rv = vapi_dispatch(ctx);
    }
  } else {
    vapi_msg_sr_localsid_add_del_ntoh(msg);
    if (VAPI_OK != vapi_producer_unlock (ctx)) {
      abort (); /* this really shouldn't happen */
    }
  }
  return rv;
}



static void __attribute__((constructor)) __vapi_constructor_sr_policy_mod_reply()
{
  static const char name[] = "sr_policy_mod_reply";
  static const char name_with_crc[] = "sr_policy_mod_reply_e53e8c2a";
  static vapi_message_desc_t __vapi_metadata_sr_policy_mod_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sr_policy_mod_reply, payload),
    sizeof(vapi_msg_sr_policy_mod_reply),
    (generic_swap_fn_t)vapi_msg_sr_policy_mod_reply_hton,
    (generic_swap_fn_t)vapi_msg_sr_policy_mod_reply_ntoh,
    ~0,
  };

  vapi_msg_id_sr_policy_mod_reply = vapi_register_msg(&__vapi_metadata_sr_policy_mod_reply);
  VAPI_DBG("Assigned msg id %d to sr_policy_mod_reply", vapi_msg_id_sr_policy_mod_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sr_steering_add_del()
{
  static const char name[] = "sr_steering_add_del";
  static const char name_with_crc[] = "sr_steering_add_del_61da4dae";
  static vapi_message_desc_t __vapi_metadata_sr_steering_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_sr_steering_add_del, payload),
    sizeof(vapi_msg_sr_steering_add_del),
    (generic_swap_fn_t)vapi_msg_sr_steering_add_del_hton,
    (generic_swap_fn_t)vapi_msg_sr_steering_add_del_ntoh,
    ~0,
  };

  vapi_msg_id_sr_steering_add_del = vapi_register_msg(&__vapi_metadata_sr_steering_add_del);
  VAPI_DBG("Assigned msg id %d to sr_steering_add_del", vapi_msg_id_sr_steering_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_sr_policy_del()
{
  static const char name[] = "sr_policy_del";
  static const char name_with_crc[] = "sr_policy_del_cc9e015e";
  static vapi_message_desc_t __vapi_metadata_sr_policy_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_sr_policy_del, payload),
    sizeof(vapi_msg_sr_policy_del),
    (generic_swap_fn_t)vapi_msg_sr_policy_del_hton,
    (generic_swap_fn_t)vapi_msg_sr_policy_del_ntoh,
    ~0,
  };

  vapi_msg_id_sr_policy_del = vapi_register_msg(&__vapi_metadata_sr_policy_del);
  VAPI_DBG("Assigned msg id %d to sr_policy_del", vapi_msg_id_sr_policy_del);
}

static void __attribute__((constructor)) __vapi_constructor_sr_localsid_add_del()
{
  static const char name[] = "sr_localsid_add_del";
  static const char name_with_crc[] = "sr_localsid_add_del_ccf1dfb7";
  static vapi_message_desc_t __vapi_metadata_sr_localsid_add_del = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header2_t, context),
    offsetof(vapi_msg_sr_localsid_add_del, payload),
    sizeof(vapi_msg_sr_localsid_add_del),
    (generic_swap_fn_t)vapi_msg_sr_localsid_add_del_hton,
    (generic_swap_fn_t)vapi_msg_sr_localsid_add_del_ntoh,
    ~0,
  };

  vapi_msg_id_sr_localsid_add_del = vapi_register_msg(&__vapi_metadata_sr_localsid_add_del);
  VAPI_DBG("Assigned msg id %d to sr_localsid_add_del", vapi_msg_id_sr_localsid_add_del);
}

static void __attribute__((constructor)) __vapi_constructor_sr_steering_add_del_reply()
{
  static const char name[] = "sr_steering_add_del_reply";
  static const char name_with_crc[] = "sr_steering_add_del_reply_8461b882";
  static vapi_message_desc_t __vapi_metadata_sr_steering_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sr_steering_add_del_reply, payload),
    sizeof(vapi_msg_sr_steering_add_del_reply),
    (generic_swap_fn_t)vapi_msg_sr_steering_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_sr_steering_add_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_sr_steering_add_del_reply = vapi_register_msg(&__vapi_metadata_sr_steering_add_del_reply);
  VAPI_DBG("Assigned msg id %d to sr_steering_add_del_reply", vapi_msg_id_sr_steering_add_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sr_policy_del_reply()
{
  static const char name[] = "sr_policy_del_reply";
  static const char name_with_crc[] = "sr_policy_del_reply_3315338b";
  static vapi_message_desc_t __vapi_metadata_sr_policy_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sr_policy_del_reply, payload),
    sizeof(vapi_msg_sr_policy_del_reply),
    (generic_swap_fn_t)vapi_msg_sr_policy_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_sr_policy_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_sr_policy_del_reply = vapi_register_msg(&__vapi_metadata_sr_policy_del_reply);
  VAPI_DBG("Assigned msg id %d to sr_policy_del_reply", vapi_msg_id_sr_policy_del_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sr_policy_add_reply()
{
  static const char name[] = "sr_policy_add_reply";
  static const char name_with_crc[] = "sr_policy_add_reply_1fa4bf69";
  static vapi_message_desc_t __vapi_metadata_sr_policy_add_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sr_policy_add_reply, payload),
    sizeof(vapi_msg_sr_policy_add_reply),
    (generic_swap_fn_t)vapi_msg_sr_policy_add_reply_hton,
    (generic_swap_fn_t)vapi_msg_sr_policy_add_reply_ntoh,
    ~0,
  };

  vapi_msg_id_sr_policy_add_reply = vapi_register_msg(&__vapi_metadata_sr_policy_add_reply);
  VAPI_DBG("Assigned msg id %d to sr_policy_add_reply", vapi_msg_id_sr_policy_add_reply);
}

static void __attribute__((constructor)) __vapi_constructor_sr_localsid_add_del_reply()
{
  static const char name[] = "sr_localsid_add_del_reply";
  static const char name_with_crc[] = "sr_localsid_add_del_reply_8ed0f725";
  static vapi_message_desc_t __vapi_metadata_sr_localsid_add_del_reply = {
    name,
    sizeof(name) - 1,
    name_with_crc,
    sizeof(name_with_crc) - 1,
    true,
    offsetof(vapi_type_msg_header1_t, context),
    offsetof(vapi_msg_sr_localsid_add_del_reply, payload),
    sizeof(vapi_msg_sr_localsid_add_del_reply),
    (generic_swap_fn_t)vapi_msg_sr_localsid_add_del_reply_hton,
    (generic_swap_fn_t)vapi_msg_sr_localsid_add_del_reply_ntoh,
    ~0,
  };

  vapi_msg_id_sr_localsid_add_del_reply = vapi_register_msg(&__vapi_metadata_sr_localsid_add_del_reply);
  VAPI_DBG("Assigned msg id %d to sr_localsid_add_del_reply", vapi_msg_id_sr_localsid_add_del_reply);
}


static inline void vapi_set_vapi_msg_sr_policy_mod_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sr_policy_mod_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sr_policy_mod_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_sr_steering_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sr_steering_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sr_steering_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_sr_policy_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sr_policy_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sr_policy_del_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_sr_policy_add_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sr_policy_add_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sr_policy_add_reply, (vapi_event_cb)callback, callback_ctx);
};

static inline void vapi_set_vapi_msg_sr_localsid_add_del_reply_event_cb (
  struct vapi_ctx_s *ctx, 
  vapi_error_e (*callback)(struct vapi_ctx_s *ctx, void *callback_ctx, vapi_payload_sr_localsid_add_del_reply *payload),
  void *callback_ctx)
{
  vapi_set_event_cb(ctx, vapi_msg_id_sr_localsid_add_del_reply, (vapi_event_cb)callback, callback_ctx);
};


#ifdef __cplusplus
}
#endif

#endif
